diff --git a/src/mongo/db/dur_journalformat.h b/src/mongo/db/dur_journalformat.h
index 10ed848..da9e35c 100644
--- a/src/mongo/db/dur_journalformat.h
+++ b/src/mongo/db/dur_journalformat.h
@@ -41,7 +41,7 @@ namespace mongo {
 #else
             enum { CurrentVersion = 0x4149 };
 #endif
-            unsigned short _version;
+            little<unsigned short> _version;
 
             // these are just for diagnostic ease (make header more useful as plain text)
             char n1;          // '\n'
@@ -50,7 +50,7 @@ namespace mongo {
             char dbpath[128]; // path/filename of this file for human reading and diagnostics.  not used by code.
             char n3, n4;      // '\n', '\n'
 
-            unsigned long long fileId; // unique identifier that will be in each JSectHeader. important as we recycle prealloced files
+            little<unsigned long long> fileId; // unique identifier that will be in each JSectHeader. important as we recycle prealloced files
 
             char reserved3[8026]; // 8KB total for the file header
             char txt2[2];         // "\n\n" at the end
@@ -65,10 +65,10 @@ namespace mongo {
         */
         struct JSectHeader {
         private:
-            unsigned _sectionLen;          // unpadded length in bytes of the whole section
+            little<unsigned> _sectionLen;          // unpadded length in bytes of the whole section
         public:
-            unsigned long long seqNumber;  // sequence number that can be used on recovery to not do too much work
-            unsigned long long fileId;     // matches JHeader::fileId
+            little<unsigned long long> seqNumber;  // sequence number that can be used on recovery to not do too much work
+            little<unsigned long long> fileId;     // matches JHeader::fileId
             unsigned sectionLen() const { return _sectionLen; }
 
             // we store the unpadded length so we can use that when we uncompress. to 
@@ -94,22 +94,22 @@ namespace mongo {
                 OpCode_Min         = 0xfffff000
             };
             union {
-                unsigned len;    // length in bytes of the data of the JEntry. does not include the JEntry header
-                OpCodes opcode;
+                little_pod<unsigned> len; // length in bytes of the data of the JEntry. does not include the JEntry header
+                little_pod<OpCodes> opcode;
             };
 
-            unsigned ofs;  // offset in file
+            little<unsigned> ofs;  // offset in file
 
             // sentinel and masks for _fileNo
             enum {
                 DotNsSuffix = 0x7fffffff, // ".ns" file
                 LocalDbBit  = 0x80000000  // assuming "local" db instead of using the JDbContext
             };
-            int _fileNo;   // high bit is set to indicate it should be the <dbpath>/local database
+            little<int> _fileNo;   // high bit is set to indicate it should be the <dbpath>/local database
             // char data[len] follows
 
             const char * srcData() const {
-                const int *i = &_fileNo;
+                const little<int> *i = &_fileNo;
                 return (const char *) (i+1);
             }
 
@@ -133,9 +133,9 @@ namespace mongo {
         struct JSectFooter {
             JSectFooter();
             JSectFooter(const void* begin, int len); // needs buffer to compute hash
-            unsigned sentinel;
+            little<unsigned> sentinel;
             unsigned char hash[16];
-            unsigned long long reserved;
+            little<unsigned long long> reserved;
             char magic[4]; // "\n\n\n\n"
 
             /** used by recovery to see if buffer is valid
@@ -145,23 +145,23 @@ namespace mongo {
             */
             bool checkHash(const void* begin, int len) const;
 
-            bool magicOk() const { return *((unsigned*)magic) == 0x0a0a0a0a; }
+            bool magicOk() const { return little<unsigned>::ref( magic ) == 0x0a0a0a0a; }
         };
 
         /** declares "the next entry(s) are for this database / file path prefix" */
         struct JDbContext {
             JDbContext() : sentinel(JEntry::OpCode_DbContext) { }
-            const unsigned sentinel;   // compare to JEntry::len -- zero is our sentinel
+            const little<unsigned> sentinel;   // compare to JEntry::len -- zero is our sentinel
             //char dbname[];
         };
 
         /** "last sequence number" */
         struct LSNFile {
-            unsigned ver;
-            unsigned reserved2;
-            unsigned long long lsn;
-            unsigned long long checkbytes;
-            unsigned long long reserved[8];
+            little<unsigned> ver;
+            little<unsigned> reserved2;
+            little<unsigned long long> lsn;
+            little<unsigned long long> checkbytes;
+            little<unsigned long long> reserved[8];
 
             void set(unsigned long long lsn);
             unsigned long long get();
diff --git a/src/mongo/db/dur_recover.cpp b/src/mongo/db/dur_recover.cpp
index 58dacff..42a7b87 100644
--- a/src/mongo/db/dur_recover.cpp
+++ b/src/mongo/db/dur_recover.cpp
@@ -593,7 +593,7 @@ namespace mongo {
             _recover(); // throws on interruption
         }
 
-        struct BufReaderY { int a,b; };
+        struct BufReaderY { little<int> a,b; };
         class BufReaderUnitTest : public StartupTest {
         public:
             void run() {
diff --git a/src/mongo/db/extsort.cpp b/src/mongo/db/extsort.cpp
index d955acb..3326c38 100644
--- a/src/mongo/db/extsort.cpp
+++ b/src/mongo/db/extsort.cpp
@@ -329,7 +329,7 @@ namespace mongo {
     BSONObjExternalSorter::Data BSONObjExternalSorter::FileIterator::next() {
         // read BSONObj
 
-        int size;
+        little<int> size;
         verify( _read( reinterpret_cast<char*>(&size), 4 ) );
         char* buf = reinterpret_cast<char*>( malloc( sizeof(unsigned) + size ) );
         verify( buf );
diff --git a/src/mongo/db/geo/2d.cpp b/src/mongo/db/geo/2d.cpp
index e1e21ee..c8d68cc 100644
--- a/src/mongo/db/geo/2d.cpp
+++ b/src/mongo/db/geo/2d.cpp
@@ -2508,7 +2508,7 @@ namespace mongo {
                 cout << "\t" << h.toString()
                      << "\t" << c.current()[g->_geo]
                      << "\t" << hex << h.getHash()
-                     << "\t" << hex << ((long long*)c.currKey().firstElement().binData(len))[0]
+                     << "\t" << hex << little<long long>::ref( c.currKey().firstElement().binData(len) )
                      << "\t" << c.current()["_id"]
                      << endl;
                 c.advance();
@@ -2540,6 +2540,7 @@ namespace mongo {
                 BSONObj in = BSON("x" << x << "y" << y);
                 GeoHash h = conv.hash(in);
                 BSONObj out = conv.unhashToBSONObj(h);
+
                 verify(round(x) == round(out["x"].number()));
                 verify(round(y) == round(out["y"].number()));
                 verify(round(in["x"].number()) == round(out["x"].number()));
diff --git a/src/mongo/db/geo/hash.h b/src/mongo/db/geo/hash.h
index ba6a9b3..4a55421 100644
--- a/src/mongo/db/geo/hash.h
+++ b/src/mongo/db/geo/hash.h
@@ -116,7 +116,7 @@ namespace mongo {
         void unhash_fast(unsigned *x, unsigned *y) const;
         void unhash_slow(unsigned *x, unsigned *y) const;
 
-        long long _hash;
+        little<long long> _hash;
         // Bits per field.  Our hash is 64 bits, and we have an X and a Y field,
         // so this is 1 to 32.
         unsigned _bits;
diff --git a/src/mongo/db/hasher.cpp b/src/mongo/db/hasher.cpp
index ae51d87..e7f49bb 100644
--- a/src/mongo/db/hasher.cpp
+++ b/src/mongo/db/hasher.cpp
@@ -53,7 +53,7 @@ namespace mongo {
                                            const BSONElement& e ,
                                            bool includeFieldName ) {
 
-        int canonicalType = e.canonicalType();
+        little<int> canonicalType = e.canonicalType();
         h->addData( &canonicalType , sizeof( canonicalType ) );
 
         if ( includeFieldName ){
@@ -64,7 +64,7 @@ namespace mongo {
             //if there are no embedded objects (subobjects or arrays),
             //compute the hash, squashing numeric types to 64-bit ints
             if ( e.isNumber() ){
-                long long int i = e.safeNumberLong(); //well-defined for troublesome doubles
+                little<long long int> i = e.safeNumberLong(); //well-defined for troublesome doubles
                 h->addData( &i , sizeof( i ) );
             }
             else {
@@ -96,7 +96,15 @@ namespace mongo {
         void run() {
             // Hard-coded check to ensure the hash function is consistent across platforms
             BSONObj o = BSON( "check" << 42 );
-            verify( BSONElementHasher::hash64( o.firstElement(), 0 ) == -944302157085130861LL );
+
+#ifdef __BIG_ENDIAN__
+            long long expected_hash = 0x933f4ef6302ae5f2LL;
+#else
+            long long expected_hash = 0xf2e52a30f64e3f93LL;
+#endif
+            long long result = BSONElementHasher::hash64(o.firstElement(), 0);
+
+            verify( result == expected_hash);
         }
     } hasherUnitTest;
 }
diff --git a/src/mongo/db/instance.cpp b/src/mongo/db/instance.cpp
index c4fb9f7..1e0e358 100644
--- a/src/mongo/db/instance.cpp
+++ b/src/mongo/db/instance.cpp
@@ -118,8 +118,8 @@ namespace mongo {
 
     // OpTime::now() uses mutex, thus it is in this file not in the cpp files used by drivers and such
     void BSONElementManipulator::initTimestamp() {
-        massert( 10332 ,  "Expected CurrentTime type", _element.type() == Timestamp );
-        unsigned long long &timestamp = *( reinterpret_cast< unsigned long long* >( value() ) );
+        massert( 10332 ,  "Expected CurrentTime type", _element.type() == Timestamp );        
+        little<unsigned long long> &timestamp = little< unsigned long long >::ref( value() );
         if ( timestamp == 0 ) {
             mutex::scoped_lock lk(OpTime::m);
             timestamp = OpTime::now(lk).asDate();
@@ -127,18 +127,18 @@ namespace mongo {
     }
     void BSONElementManipulator::SetNumber(double d) {
         if ( _element.type() == NumberDouble )
-            *getDur().writing( reinterpret_cast< double * >( value() )  ) = d;
+            *getDur().writing( &little< double >::ref( value() ) ) = d;
         else if ( _element.type() == NumberInt )
-            *getDur().writing( reinterpret_cast< int * >( value() ) ) = (int) d;
+            *getDur().writing( &little< int >::ref( value() ) ) = (int) d;
         else verify(0);
     }
     void BSONElementManipulator::SetLong(long long n) {
         verify( _element.type() == NumberLong );
-        *getDur().writing( reinterpret_cast< long long * >(value()) ) = n;
+        *getDur().writing( &little< long long >::ref( value() ) ) = n;
     }
     void BSONElementManipulator::SetInt(int n) {
         verify( _element.type() == NumberInt );
-        getDur().writingInt( *reinterpret_cast< int * >( value() ) ) = n;
+        getDur().writingInt( little< int >::ref( value() ) ) = n;
     }
     /* dur:: version */
     void BSONElementManipulator::ReplaceTypeAndValue( const BSONElement &e ) {
@@ -1039,7 +1039,7 @@ namespace mongo {
         // uh - oh, not sure there is anything else we can do...
     }
 
-    static void shutdownServer() {
+    void shutdownServer() {
 
         log() << "shutdown: going to close listening sockets..." << endl;
         ListeningSockets::get()->closeAll();
diff --git a/src/mongo/db/jsobj.cpp b/src/mongo/db/jsobj.cpp
index ea3248e..972adaf 100644
--- a/src/mongo/db/jsobj.cpp
+++ b/src/mongo/db/jsobj.cpp
@@ -179,11 +179,10 @@ namespace mongo {
             }
             break;
         case BinData: {
-            const int len = *( reinterpret_cast<const int*>( value() ) );
-            BinDataType type = BinDataType( *( reinterpret_cast<const unsigned char*>( value() ) +
-                                               sizeof( int ) ) );
+            int len = little<int>::ref( value() );
+            BinDataType type = BinDataType( *reinterpret_cast<const signed char*>( value() + 4 ) );
             s << "{ \"$binary\" : \"";
-            const char *start = reinterpret_cast<const char*>( value() ) + sizeof( int ) + 1;
+            char *start = ( char * )( value() ) + sizeof( int ) + 1;
             base64::encode( s , start , len );
             s << "\", \"$type\" : \"" << hex;
             s.width( 2 );
@@ -967,7 +966,7 @@ namespace mongo {
             name=0;
             eoo=EOO;
         }
-        int totsize;
+        little<int> totsize;
         char maxkey;
         char name;
         char eoo;
@@ -981,7 +980,7 @@ namespace mongo {
             name=0;
             eoo=EOO;
         }
-        int totsize;
+        little<int> totsize;
         char minkey;
         char name;
         char eoo;
@@ -994,7 +993,7 @@ namespace mongo {
                 totsize = 5;
                 eoo = EOO;
             }
-            int totsize;
+            little<int> totsize;
             char eoo;
         } js0;
     */
diff --git a/src/mongo/db/jsobjmanipulator.h b/src/mongo/db/jsobjmanipulator.h
index 0566640..ac605cf 100644
--- a/src/mongo/db/jsobjmanipulator.h
+++ b/src/mongo/db/jsobjmanipulator.h
@@ -41,19 +41,19 @@ namespace mongo {
 
         /** Change the value, in place, of the number. */
         void setNumber(double d) {
-            if ( _element.type() == NumberDouble ) *reinterpret_cast< double * >( value() )  = d;
-            else if ( _element.type() == NumberInt ) *reinterpret_cast< int * >( value() ) = (int) d;
+            if ( _element.type() == NumberDouble ) little< double >::ref( value() )  = d;
+            else if ( _element.type() == NumberInt ) little< int >::ref( value() ) = (int) d;
             else verify(0);
         }
         void SetNumber(double d);
         void setLong(long long n) {
             verify( _element.type() == NumberLong );
-            *reinterpret_cast< long long * >( value() ) = n;
+            little< long long >::ref( value() ) = n;
         }
         void SetLong(long long n);
         void setInt(int n) {
             verify( _element.type() == NumberInt );
-            *reinterpret_cast< int * >( value() ) = n;
+            little< int >::ref( value() ) = n;
         }
         void SetInt(int n);
 
diff --git a/src/mongo/db/key.cpp b/src/mongo/db/key.cpp
index 3d9eaa7..7a197e2 100644
--- a/src/mongo/db/key.cpp
+++ b/src/mongo/db/key.cpp
@@ -294,7 +294,7 @@ namespace mongo {
                 }
             case Date:
                 b.appendUChar(cdate|bits);
-                b.appendStruct(e.date());
+                b.appendNum( ( unsigned long long) e.date());
                 break;
             case String:
                 {
@@ -402,19 +402,19 @@ namespace mongo {
                         break;
                     }
                 case cdate:
-                    b.appendDate("", (Date_t&) *p);
+                    b.appendDate("", Date_t( little<unsigned long long>::ref( p ) ));
                     p += 8;
                     break;
                 case cdouble:
-                    b.append("", (double&) *p);
+                    b.append("", little<double>::ref( p ));
                     p += sizeof(double);
                     break;
                 case cint:
-                    b.append("", static_cast< int >((reinterpret_cast< const PackedDouble& >(*p)).d));
+                    b.append("", static_cast< int >( little<double>::ref( p ) ) );
                     p += sizeof(double);
                     break;
                 case clong:
-                    b.append("", static_cast< long long>((reinterpret_cast< const PackedDouble& >(*p)).d));
+                    b.append("", static_cast< long long>( little<double>::ref( p ) ) );
                     p += sizeof(double);
                     break;
                 default:
@@ -440,8 +440,8 @@ namespace mongo {
         switch( lt ) { 
         case cdouble:
             {
-                double L = (reinterpret_cast< const PackedDouble* >(l))->d;
-                double R = (reinterpret_cast< const PackedDouble* >(r))->d;
+                double L = little<double>::ref( l );
+                double R = little<double>::ref( r );
                 if( L < R )
                     return -1;
                 if( L != R )
@@ -489,8 +489,8 @@ namespace mongo {
             }
         case cdate:
             {
-                long long L = *((long long *) l);
-                long long R = *((long long *) r);
+                long long L = little<long long>::ref( l );
+                long long R = little<long long>::ref( r );
                 if( L < R )
                     return -1;
                 if( L > R )
@@ -620,16 +620,16 @@ namespace mongo {
             l++; r++;
             switch( lval&cCANONTYPEMASK ) { 
             case coid:
-                if( *((unsigned*) l) != *((unsigned*) r) )
+                if ( little<unsigned>::ref( l ) != little<unsigned>::ref( r ) )
                     return false;
                 l += 4; r += 4;
             case cdate:
-                if( *((unsigned long long *) l) != *((unsigned long long *) r) )
+                if ( little<unsigned long long>::ref( l ) != little<unsigned long long>::ref( r ) )
                     return false;
                 l += 8; r += 8;
                 break;
             case cdouble:
-                if( (reinterpret_cast< const PackedDouble* > (l))->d != (reinterpret_cast< const PackedDouble* >(r))->d )
+                if ( little<double>::ref( l ) != little<double>::ref( r ) )
                     return false;
                 l += 8; r += 8;
                 break;
diff --git a/src/mongo/db/matcher.cpp b/src/mongo/db/matcher.cpp
index 532c18e..c116ccc 100644
--- a/src/mongo/db/matcher.cpp
+++ b/src/mongo/db/matcher.cpp
@@ -1267,15 +1267,15 @@ namespace mongo {
             strcpy_s(sval, 10, "123456789");
             eoo = EOO;
         }
-        unsigned totsize;
+        little<unsigned> totsize;
 
         char n;
         char nname[5];
-        double N;
+        little<double> N;
 
         char s;
         char sname[7];
-        unsigned slen;
+        little<unsigned> slen;
         char sval[10];
 
         char eoo;
@@ -1294,10 +1294,10 @@ namespace mongo {
             strcpy_s(sval, 10, "123456789");
             eoo = EOO;
         }
-        unsigned totsize;
+        little<unsigned> totsize;
         char s;
         char sname[7];
-        unsigned slen;
+        little<unsigned> slen;
         char sval[10];
         char eoo;
     } js2;
diff --git a/src/mongo/db/namespace_details.cpp b/src/mongo/db/namespace_details.cpp
index 360e3dd..a113530 100644
--- a/src/mongo/db/namespace_details.cpp
+++ b/src/mongo/db/namespace_details.cpp
@@ -254,7 +254,7 @@ namespace mongo {
             Record *r = (Record *) getDur().writingPtr(d, sizeof(Record));
             d = &r->asDeleted();
             // defensive code: try to make us notice if we reference a deleted record
-            reinterpret_cast<unsigned*>( r->data() )[0] = 0xeeeeeeee;
+            little<unsigned>::ref( r->data() ) = 0xeeeeeeee; 
         }
         DEBUGGING log() << "TEMP: add deleted rec " << dloc.toString() << ' ' << hex << d->extentOfs() << endl;
         if ( isCapped() ) {
@@ -355,7 +355,8 @@ namespace mongo {
         if ( !isCapped() && NamespaceString::normal( ns ) ) {
             // we quantize here so that it only impacts newly sized records
             // this prevents oddities with older records and space re-use SERVER-8435
-            lenToAlloc = std::min( r->lengthWithHeaders(),
+            // hcj have to cast the first one from little<int> to int
+            lenToAlloc = std::min( (int)r->lengthWithHeaders(),
                                    NamespaceDetails::quantizeAllocationSpace( lenToAlloc ) );
             left = regionlen - lenToAlloc;
 
diff --git a/src/mongo/db/namespace_details.h b/src/mongo/db/namespace_details.h
index 3f38160..debe233 100644
--- a/src/mongo/db/namespace_details.h
+++ b/src/mongo/db/namespace_details.h
@@ -71,48 +71,48 @@ namespace mongo {
         // ofs 168 (8 byte aligned)
         struct Stats {
             // datasize and nrecords MUST Be adjacent code assumes!
-            long long datasize; // this includes padding, but not record headers
-            long long nrecords;
+            little<long long> datasize; // this includes padding, but not record headers
+            little<long long> nrecords;
         } stats;
-        int lastExtentSize;
-        int nIndexes;
+        little<int> lastExtentSize;
+        little<int> nIndexes;
     private:
         // ofs 192
         IndexDetails _indexes[NIndexesBase];
 
         // ofs 352 (16 byte aligned)
-        int _isCapped;                         // there is wasted space here if I'm right (ERH)
-        int _maxDocsInCapped;                  // max # of objects for a capped table, -1 for inf.
+        little<int> _isCapped;                         // there is wasted space here if I'm right (ERH)
+        little<int> _maxDocsInCapped;                  // max # of objects for a capped table.  TODO: should this be 64 bit?
 
-        double _paddingFactor;                 // 1.0 = no padding.
+        little<double> _paddingFactor;                 // 1.0 = no padding.
         // ofs 386 (16)
-        int _systemFlags; // things that the system sets/cares about
+        little<int> _systemFlags; // things that the system sets/cares about
     public:
         DiskLoc capExtent; // the "current" extent we're writing too for a capped collection
         DiskLoc capFirstNewRecord;
-        unsigned short dataFileVersion;       // NamespaceDetails version.  So we can do backward compatibility in the future. See filever.h
-        unsigned short indexFileVersion;
-        unsigned long long multiKeyIndexBits;
+        little<unsigned short> dataFileVersion;       // NamespaceDetails version.  So we can do backward compatibility in the future. See filever.h
+        little<unsigned short> indexFileVersion;
+        little<unsigned long long> multiKeyIndexBits;
     private:
         // ofs 400 (16)
-        unsigned long long reservedA;
-        long long extraOffset;                // where the $extra info is located (bytes relative to this)
+        little<unsigned long long> reservedA;
+        little<long long> extraOffset;                // where the $extra info is located (bytes relative to this)
     public:
-        int indexBuildsInProgress;            // Number of indexes currently being built
+        little<int> indexBuildsInProgress;             // 1 if in prog
     private:
-        int _userFlags;
+        little<int> _userFlags;
         char reserved[72];
         /*-------- end data 496 bytes */
     public:
         explicit NamespaceDetails( const DiskLoc &loc, bool _capped );
 
         class Extra {
-            long long _next;
+            little<long long> _next;
         public:
             IndexDetails details[NIndexesExtra];
         private:
-            unsigned reserved2;
-            unsigned reserved3;
+            little<unsigned> reserved2;
+            little<unsigned> reserved3;
             Extra(const Extra&) { verify(false); }
             Extra& operator=(const Extra& r) { verify(false); return *this; }
         public:
@@ -183,7 +183,7 @@ namespace mongo {
         /* when a background index build is in progress, we don't count the index in nIndexes until
            complete, yet need to still use it in _indexRecord() - thus we use this function for that.
         */
-        int getTotalIndexCount() const { return nIndexes + indexBuildsInProgress; }
+        little<int> getTotalIndexCount() const { return nIndexes + indexBuildsInProgress; }
 
         /* NOTE: be careful with flags.  are we manipulating them in read locks?  if so,
                  this isn't thread safe.  TODO
@@ -282,7 +282,7 @@ namespace mongo {
                    can pushes this down considerably. further tweaking will be a good idea but 
                    this should be an adequate starting point.
                 */
-                double N = min(nIndexes,7) + 3;
+                double N = min( nIndexes + 0, 7 ) + 3;
                 double x = _paddingFactor + (0.001 * N);
                 if ( x <= 2.0 ) {
                     setPaddingFactor( x );
diff --git a/src/mongo/db/oplog.cpp b/src/mongo/db/oplog.cpp
index 3399036..14e887d 100644
--- a/src/mongo/db/oplog.cpp
+++ b/src/mongo/db/oplog.cpp
@@ -132,7 +132,7 @@ namespace mongo {
         memcpy(p, partial.objdata(), size1);
 
         // adjust overall bson object size for the o: field
-        *(static_cast<unsigned*>(p)) += o.objsize() + 1/*fieldtype byte*/ + 2/*"o" fieldname*/;
+        little<unsigned>::ref( p ) += o.objsize() + 1/*fieldtype byte*/ + 2/*"o" fieldname*/;
 
         char *b = static_cast<char *>(p);
         b += size1;
diff --git a/src/mongo/db/ops/query.cpp b/src/mongo/db/ops/query.cpp
index 48a191b..04fcda0 100644
--- a/src/mongo/db/ops/query.cpp
+++ b/src/mongo/db/ops/query.cpp
@@ -825,7 +825,7 @@ namespace mongo {
         
         QueryResult *qr = (QueryResult *) result.header();
         qr->cursorId = cursorid;
-        curop.debug().cursorid = ( cursorid == 0 ? -1 : qr->cursorId );
+        curop.debug().cursorid = ( cursorid == 0 ?(little<long long int>)-1 : qr->cursorId );
         qr->setResultFlagsToOk();
         // qr->len is updated automatically by appendData()
         curop.debug().responseLength = qr->len;
diff --git a/src/mongo/db/pdfile.cpp b/src/mongo/db/pdfile.cpp
index aa49b15..0e26041 100644
--- a/src/mongo/db/pdfile.cpp
+++ b/src/mongo/db/pdfile.cpp
@@ -536,7 +536,7 @@ namespace mongo {
         massert( 10357 ,  "shutdown in progress", ! inShutdown() );
         massert( 10358 ,  "bad new extent size", approxSize >= Extent::minSize() && approxSize <= Extent::maxSize() );
         massert( 10359 ,  "header==0 on new extent: 32 bit mmap space exceeded?", header() ); // null if file open failed
-        int ExtentSize = min(header()->unusedLength, approxSize);
+        int ExtentSize = min( header()->unusedLength + 0, approxSize );
         DiskLoc loc;
         if ( ExtentSize < Extent::minSize() ) {
             /* note there could be a lot of looping here is db just started and
@@ -672,7 +672,7 @@ namespace mongo {
         delRecLength = extentLength - Extent::HeaderSize();
         if( delRecLength >= 32*1024 && str::contains(ns, '$') && !capped ) { 
             // probably an index. so skip forward to keep its records page aligned 
-            int& ofs = emptyLoc.GETOFS();
+            little<int>& ofs = emptyLoc.GETOFS();
             int newOfs = (ofs + 0xfff) & ~0xfff; 
             delRecLength -= (newOfs-ofs);
             dassert( delRecLength > 0 );
@@ -1087,7 +1087,7 @@ namespace mongo {
             }
             else {
                 DEV {
-                    unsigned long long *p = reinterpret_cast<unsigned long long *>( todelete->data() );
+                    little<unsigned long long> *p = &little<unsigned long long >::ref( todelete->data() );
                     *getDur().writing(p) = 0;
                     //DEV memset(todelete->data, 0, todelete->netLength()); // attempt to notice invalid reuse.
                 }
@@ -1657,9 +1657,8 @@ namespace mongo {
                 len = fixedIndexObject.objsize();
             }
         }
-
         IDToInsert idToInsert; // only initialized if needed
-
+       // int addID = 0; // 0 if not adding _id; if adding, the length of that new element
         if( !god ) {
             /* Check if we have an _id field. If we don't, we'll add it.
                Note that btree buckets which we insert aren't BSONObj's, but in that case god==true.
@@ -1682,7 +1681,6 @@ namespace mongo {
 
             BSONElementManipulator::lookForTimestamps( io );
         }
-
         int lenWHdr = d->getRecordAllocationSize( len + Record::HeaderSize );
         fassert( 16440, lenWHdr >= ( len + Record::HeaderSize ) );
         
@@ -1734,26 +1732,23 @@ namespace mongo {
             DiskLoc real = allocateSpaceForANewRecord(ns, d, lenWHdr, god);
             verify( real == loc );
         }
-
         Record *r = loc.rec();
         {
             verify( r->lengthWithHeaders() >= lenWHdr );
             r = (Record*) getDur().writingPtr(r, lenWHdr);
             if( idToInsert.needed() ) {
                 /* a little effort was made here to avoid a double copy when we add an ID */
-                int originalSize = *((int*) obuf);
-                ((int&)*r->data()) = originalSize + idToInsert.size();
+//              int originalSize = *((int*) obuf);
+                little<int>::ref( r->data() ) = little<int>::ref( obuf ) + idToInsert.size();
                 memcpy(r->data()+4, idToInsert.rawdata(), idToInsert.size());
-                memcpy(r->data()+4+idToInsert.size(), ((char*)obuf)+4, originalSize-4);
+                memcpy(r->data()+4+idToInsert.size(), ((char *)obuf)+4, little<int>::ref( obuf )-4);
             }
             else {
                 if( obuf ) // obuf can be null from internal callers
                     memcpy(r->data(), obuf, len);
             }
         }
-
         addRecordToRecListInExtent(r, loc);
-
         /* durability todo : this could be a bit annoying / slow to record constantly */
         {
             NamespaceDetails::Stats *s = getDur().writing(&d->stats);
